/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-04 10:53
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 1e6 + 5;
const ll INF = 1LL << 60;

// from reference
template<class T, class Proj = function<ll(T)>>
struct sparse_table {
  int N, LG;
  vector<T> vs;
  vector<vector<int>> sp;
  Proj p;
  sparse_table(){} // default ctor - do not use
  sparse_table(vector<T> a, Proj p = identity())
    : N(size(a)), LG(__bit_width(N)), vs(a), p(p){
    sp.assign(LG, vector<int>(N));
    iota(begin(sp[0]), end(sp[0]), 0);
    for(int k = 0; k < LG - 1; k++)
      for(int i = 0; i + (2 << k) <= N; i++){
        int x = sp[k][i], y = sp[k][i + (1 << k)];
        sp[k + 1][i] = p(vs[x]) < p(vs[y]) ? x : y;
      }
  }
  T get(int l, int r){
    int k = __bit_width(r - l + 1) - 1;
    int x = sp[k][l], y = sp[k][r - (1 << k) + 1];
    return vs[p(vs[x]) < p(vs[y]) ? x : y];
  }
};

vector<int> edges[MAXN];
struct lca_tree {
  int N, t = 0;
  vector<ll> tv, tin, d;
  sparse_table<ll> st;
  lca_tree(int root, int num)
    : N(num), tv(2 * N), tin(N), d(N){
    dfs(root);
    auto p = [&](ll x){ return d[x]; };
    st = sparse_table<ll>(tv, p);
  }
  void dfs(int v, int de = 1){
    d[v] = de, tv[tin[v] = ++t] = v;
    for(int w : edges[v])
      if(!tin[w]) dfs(w, de + 1), tv[++t] = v;
  }
  int lca(int a, int b){
    auto [l, r] = minmax(tin[a], tin[b]);
    return st.get(l, r);
  }
  int dist(int a, int b){
    return d[a] + d[b] - 2 * d[lca(a, b)];
  }
};
// vector<int> edges[MAXN];
// struct lca_tree {
//   struct node { int id, de, tin; };
//   int N, t = 0;
//   vector<node> ns, tv;
//   sparse_table<node> st;
//   lca_tree(int root, int num)
//     : N(num), ns(N), tv(2 * N){
//     dfs(root);
//     st = sparse_table<node>(tv, &node::de);
//   }
//   void dfs(int v, int de = 1){
//     ns[v] = {v, de, ++t}, tv[t] = ns[v];
//     for(int w : edges[v])
//       if(!ns[w].tin) dfs(w, de + 1), tv[++t] = ns[v];
//   }
//   node lca(int a, int b){
//     auto [l, r] = minmax(ns[a].tin, ns[b].tin);
//     return st.get(l, r);
//   }
//   int dist(int a, int b){
//     return ns[a].de + ns[b].de - 2 * lca(a, b).de;
//   }
// };
// from reference 

ll H, W;

void addedge(int x, int y){
    edges[x].push_back(y);
    edges[y].push_back(x);
}

void solve(){
    // Code goes here ...
    cin >> H >> W;

    vector<vector<int>> grid(H, vector<int>(W, 0));

    int vid = 0;
    string row, lastrow;
    getline(cin, row);
    getline(cin, row);
    R(i, H){
        lastrow = row;
        getline(cin, row);
        R(j, W){
            int jpos = 2 * j + 1;
            grid[i][j] = vid;

            if(i > 0 and lastrow[jpos] != '_')
                addedge(vid, vid - W);
            if(j > 0 and row[jpos - 1] != '|')
                addedge(vid, vid - 1);

            vid++;
        }
    }


    int M;
    cin >> M;

    vector<int> xs(M), ys(M);
    R(i, M) cin >> xs[i] >> ys[i];

    vector<pii> qs(M-1);
    R(i, M - 1)
        qs[i] = {
            grid[xs[i] - 1][ys[i] - 1],
            grid[xs[i + 1] - 1][ys[i + 1] - 1]
        };


    // usage
    lca_tree tree(0, vid);
    ll res = 0;
    for(auto [a, b] : qs)
        res += tree.dist(a, b);
    // usage

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
